import time, datetime

# for video
import glob
import numpy as np
import imageio.v3 as iio
import os

import numpy as np

from pygifsicle import optimize


start_time = time.time()

def elapsed_time(start):
    end_time = time.time()
    duration = round(end_time - start)
    timestamp = str(datetime.timedelta(seconds = duration))
    print(timestamp)


# https://www.datacamp.com/tutorial/networkx-python-graph-tutorial
def make_circuit_video(image_path, movie_filename, fps=5):
    # sorting filenames in order
    filenames = glob.glob(image_path + 'img*.png')
    filenames_sort_indices = np.argsort([int(os.path.basename(filename).split('.')[0][3:]) for filename in filenames])
    filenames = [filenames[i] for i in filenames_sort_indices]

    # make movie
    frames = []
    for filename in filenames:
        frames.append(iio.imread(filename))
    iio.imwrite(movie_filename, frames, duration = 1000/fps, loop=0)


output_file = 'fig/fuzz_animation.gif'
make_circuit_video('fig/', output_file, fps=3)
elapsed_time(start_time)
print('original gif size: ',os.path.getsize(output_file))

optimize(output_file) # For overwriting the original one
print('optimized gif size: ',os.path.getsize(output_file))

elapsed_time(start_time)
print('finished script ' + os.path.basename(__file__))


